"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateRequestBodiesDefinition = void 0;
const case_1 = require("case");
const isEmpty_1 = __importDefault(require("lodash/isEmpty"));
const getResReqTypes_1 = require("./getResReqTypes");
/**
 * Extract all types from #/components/requestBodies
 */
const generateRequestBodiesDefinition = (requestBodies = {}) => {
    if ((0, isEmpty_1.default)(requestBodies)) {
        return '';
    }
    return ('\n // REQUEST BODIES \n' +
        Object.entries(requestBodies)
            .map(([name, requestBody]) => {
            const doc = (0, getResReqTypes_1.getDocs)(requestBody);
            const type = (0, getResReqTypes_1.getResReqTypes)([['', requestBody]]);
            const isEmptyInterface = type === '{}';
            if (isEmptyInterface) {
                return `export type ${(0, case_1.pascal)(name)}RequestBody = ${type}`;
            }
            else if (type.includes('{') && !type.includes('|') && !type.includes('&')) {
                return `${doc}export type ${(0, case_1.pascal)(name)}RequestBody = ${type}`;
            }
            else {
                return `${doc}export type ${(0, case_1.pascal)(name)}RequestBody = ${type};`;
            }
        })
            .join('\n\n') +
        '\n');
};
exports.generateRequestBodiesDefinition = generateRequestBodiesDefinition;
