"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateResponsesDefinition = void 0;
const case_1 = require("case");
const isEmpty_1 = __importDefault(require("lodash/isEmpty"));
const getResReqTypes_1 = require("./getResReqTypes");
/**
 * Extract all types from #/components/responses
 */
const generateResponsesDefinition = (responses = {}) => {
    if ((0, isEmpty_1.default)(responses)) {
        return '';
    }
    return ('\n // RESPONSES \n' +
        Object.entries(responses)
            .map(([name, response]) => {
            const doc = (0, getResReqTypes_1.getDocs)(response);
            const type = (0, getResReqTypes_1.getResReqTypes)([['', response]]);
            const isEmptyInterface = type === '{}';
            if (isEmptyInterface) {
                return `export type RQ${(0, case_1.pascal)(name)}Response = ${type}`;
            }
            else if (type.includes('{') && !type.includes('|') && !type.includes('&')) {
                return `${doc}export type RQ${(0, case_1.pascal)(name)}Response = ${type}`;
            }
            else {
                return `${doc}export type RQ${(0, case_1.pascal)(name)}Response = ${type};`;
            }
        })
            .join('\n\n') +
        '\n');
};
exports.generateResponsesDefinition = generateResponsesDefinition;
