"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateSchemasDefinition = void 0;
const case_1 = require("case");
const isEmpty_1 = __importDefault(require("lodash/isEmpty"));
const getResReqTypes_1 = require("./getResReqTypes");
/**
 * Generate the interface string
 */
const generateInterface = (name, schema) => {
    const scalar = (0, getResReqTypes_1.getScalar)(schema);
    return `
       ${(0, getResReqTypes_1.formatDescription)(schema.description)}
       export type ${(0, case_1.pascal)(name)} = ${scalar}
     `;
};
/**
 * Extract all types from #/components/schemas
 */
const generateSchemasDefinition = (schemas = {}) => {
    if ((0, isEmpty_1.default)(schemas)) {
        return '';
    }
    return ('\n // SCEHMAS' +
        Object.entries(schemas)
            .map(([name, schema]) => !(0, getResReqTypes_1.isReference)(schema) &&
            (!schema.type || schema.type === 'object') &&
            !schema.allOf &&
            !schema.oneOf &&
            !(0, getResReqTypes_1.isReference)(schema) &&
            !schema.nullable
            ? generateInterface(name, schema)
            : `${(0, getResReqTypes_1.formatDescription)((0, getResReqTypes_1.isReference)(schema) ? undefined : schema.description)} type ${(0, case_1.pascal)(name)} = ${(0, getResReqTypes_1.resolveValue)(schema)};`)
            .join('\n\n') +
        '\n');
};
exports.generateSchemasDefinition = generateSchemasDefinition;
