import { pascal } from 'case';
import isEmpty from 'lodash/isEmpty';
import { getDocs, getResReqTypes } from './getResReqTypes';
/**
 * Extract all types from #/components/requestBodies
 */
export const generateRequestBodiesDefinition = (requestBodies = {}) => {
    if (isEmpty(requestBodies)) {
        return '';
    }
    return ('\n // REQUEST BODIES \n' +
        Object.entries(requestBodies)
            .map(([name, requestBody]) => {
            const doc = getDocs(requestBody);
            const type = getResReqTypes([['', requestBody]]);
            const isEmptyInterface = type === '{}';
            if (isEmptyInterface) {
                return `export type ${pascal(name)}RequestBody = ${type}`;
            }
            else if (type.includes('{') && !type.includes('|') && !type.includes('&')) {
                return `${doc}export type ${pascal(name)}RequestBody = ${type}`;
            }
            else {
                return `${doc}export type ${pascal(name)}RequestBody = ${type};`;
            }
        })
            .join('\n\n') +
        '\n');
};
