import { pascal } from 'case';
import isEmpty from 'lodash/isEmpty';
import { getDocs, getResReqTypes } from './getResReqTypes';
/**
 * Extract all types from #/components/responses
 */
const generateResponsesDefinition = (responses = {}) => {
    if (isEmpty(responses)) {
        return '';
    }
    return ('\n // RESPONSES \n' +
        Object.entries(responses)
            .map(([name, response]) => {
            const doc = getDocs(response);
            const type = getResReqTypes([['', response]]);
            const isEmptyInterface = type === '{}';
            if (isEmptyInterface) {
                return `export type RQ${pascal(name)}Response = ${type}`;
            }
            else if (type.includes('{') && !type.includes('|') && !type.includes('&')) {
                return `${doc}export type RQ${pascal(name)}Response = ${type}`;
            }
            else {
                return `${doc}export type RQ${pascal(name)}Response = ${type};`;
            }
        })
            .join('\n\n') +
        '\n');
};
